// Info Viewer V1.0 Copyright (C) 1997 Wen-Shin Wang

/*-----------------------------------------------------------------
Graphic Text Environment/32 V1.0
Written by Wen-Shin Wang 01-July-1996
You can freely use this library for any purpose.
-----------------------------------------------------------------*/
#if !defined(_GTE32_H_)
#define _GTE32_H_
#ifdef __cplusplus
extern "C" {
#endif


#include "chardef.h"

#define gteDefault	0
#define gte80x30	1
#define gte80x34	2
#define gte90x30	3
#define gte90x34	4
#define gte94x30	5
#define gte94x34	6
extern int gteScreenMode;
/*
Default value is gteDefault which will use current video mode
** set before Initialize video mode
*/

extern int gteForceGraphic;
/*
Default value is 0,
Ignore all EGA checking if 1.
** set before Initialize video mode
*/

extern void gteQuitGraphicText();
extern int	gteInitGraphicText();
/*
return: 1: OK
		0: fail
*/


extern void gteQuitMouseHandle();
extern int	gteInitMouseHandle();
/*
return: 1: OK
		0: fail
*/


extern int gteSetCursorShape(int);
/*
Input:	0: arrow
		1: waiting
		2: input prompt
Output: 1: OK
		0: fail
*/

extern void gteSetCursorSwapChars(char* CharSet);
/*
Input:	The pointer of 6 characters to be swaped
Output: none

**	call before initialize mouse handle.
*/

/*
Standard use is InitGraphicText first, then InitMouseHandle,
the Mouse Handle will adjust cursor's size according to current mode
and font height.
*/

#ifdef __cplusplus
}
#endif
#endif
