#define Uses_TSystemError
#define Uses_TEventQueue
#define Uses_TScreen
#define Uses_TObject
#define Uses_TMouse
#define Uses_TApplication
#include <tv.h>

static TScreen tsc;
TMouse TEventQueue::mouse;
static TEventQueue teq;
static TSystemError sysErr;

void initHistory();
void doneHistory();

TApplication::TApplication() :
	TProgInit( &TApplication::initStatusLine,
				  &TApplication::initMenuBar,
				  &TApplication::initDeskTop
				)
{
	initHistory();
}

TApplication::~TApplication()
{
	doneHistory();
}

void TApplication::suspend()
{
	TSystemError::suspend();
	TEventQueue::suspend();
	TScreen::suspend();
}

void TApplication::resume()
{
	TScreen::resume();
	TEventQueue::resume();
	TSystemError::resume();
}
