#define Uses_TFrame
#define Uses_TDrawBuffer
#define Uses_TWindow
#define Uses_TRect
#define Uses_TPoint
#define Uses_TEvent
#define Uses_TStreamableClass
#include <tv.h>

#include <string.h>
#include <stdlib.h>

#define cpFrame "\x01\x01\x02\x02\x03"
extern int gteGraphicText;
#define GT gteGraphicText
#include "../gte32.h"

static const near IS[2][4]={{2,5,2,5},{0,2,1,2}};
static const char near GTTFrameinitFrame[18] = {4,4,4,3,4,5,6,7,8,4,4,4,3,4,5,6,7,8};
static const char near GTTFrameframeChars[] = {TopLeftBorder,TopBorder,TopRightBorder,
									LeftBorder,' ',RightBorder,
									BottomLeftBorder,BottomBorder,BottomRightBorder,
									''};
static const char near
	gteUBtn[]={UpButton1,UpButton2,0},
	gteDBtn[]={DownButton1,DownButton2,0},
	gteSBtn[]={SystemButton1,SystemButton2,0},
	gteEBtn[]={EmptyButton1,EmptyButton2,0},
	gteVScl[]={VScrollBarBody1,VScrollBarBody2,0},
	gteLBor[]={RightBorder,0};

TFrame::TFrame( const TRect& bounds ) : TView( bounds )
{
	growMode = gfGrowHiX + gfGrowHiY;
	eventMask |= evBroadcast;
}

void TFrame::draw()
{
  if (!GT) {

	ushort cFrame, cTitle;
	short  f, i, l, width;
	TDrawBuffer b;

	if( (state & sfActive) == 0 )
		{
		cFrame = 0x0101;
		cTitle = 0x0002;
		f = 0;
		}
	else
		if( (state & sfDragging) != 0 )
			{
			cFrame = 0x0505;
			cTitle = 0x0005;
			f = 0;
			}
		else
			{
			cFrame = 0x0503;
			cTitle = 0x0004;
			f = 9;
			}

	cFrame = getColor(cFrame);
	cTitle = getColor(cTitle);

	width = size.x;
	l = width - 10;

	if( ( ((TWindow *)owner)->flags & (wfClose | wfZoom) ) != 0 )
		l -= 6;
	frameLine( b, 0, f, uchar(cFrame) );
	if( ((TWindow *)owner)->number != wnNoNumber &&
		((TWindow *)owner)->number < 10
	  )
		{
		l -= 4;
		if( ( ((TWindow *)owner)->flags & wfZoom ) != 0 )
			i = 7;
		else
			i = 3;
		b.putChar( width-i, ((TWindow *)owner)->number + '0' );
		}

	if( owner != 0 )
		{
		const char *title = ((TWindow *)owner)->getTitle(l);
		if( title != 0 )
			{
			l = min( cstrlen(title), width - 10 );
			l = max( l, 0 );
			i = (width - l) >> 1;
			b.putChar( i-1, ' ' );
			b.moveBuf( i, title, cTitle, l );
			b.putChar( i+l, ' ' );
			}
		}

	if( (state & sfActive) != 0 )
		{
		if( ( ((TWindow *)owner)->flags & wfClose ) != 0 )
			b.moveCStr( IS[GT][0], closeIcon, cFrame );
		if( ( ((TWindow *)owner)->flags & wfZoom ) != 0 )
			{
			TPoint minSize, maxSize;
			owner->sizeLimits( minSize, maxSize );
			if( owner->size == maxSize )
				b.moveCStr( width-IS[GT][1], unZoomIcon, cFrame );
			else
				b.moveCStr( width-IS[GT][1], zoomIcon, cFrame );
			}
		}

	writeLine( 0, 0, size.x, 1, b );
	for( i = 1; i <=  size.y - 2; i++ )
		{
		frameLine( b, i, f +  3, cFrame );
		writeLine( 0, i, size.x, 1, b );
		}
	frameLine( b, size.y - 1, f +  6, cFrame );
	if( (state & sfActive) != 0 )
		if( ( ((TWindow *)owner)->flags & wfGrow ) != 0 )
			b.moveCStr( width-2, dragIcon, cFrame );
	writeLine( 0, size.y - 1, size.x, 1, b );
  }
  else {

	ushort cFrame, cTitle;
	short  i, l, width;
	TDrawBuffer b;

//	  if( (state & sfActive) == 0 ) cTitle = 0x97;
//	  else cTitle = 0x9f;
	if( (state & sfActive) == 0 ) cTitle = (getColor(0x02)&0x0f)+0x80;
	else cTitle = (getColor(0x04)&0x0f)+0x90;
	cFrame = (getColor(0x01)&0xf0)+0;

	width = size.x;
	l = width - 4;

	if( ( ((TWindow *)owner)->flags & (wfClose | wfZoom) ) != 0 )
		l-=2;
	frameLine( b, 0, 0, cTitle );
	if( ((TWindow *)owner)->number != wnNoNumber &&
		((TWindow *)owner)->number < 10
	  )
		{
		l -= 3;
		if( ( ((TWindow *)owner)->flags & wfZoom ) != 0 )
			i = 4;
		else
			i = 2;
		b.putChar( width-i, ((TWindow *)owner)->number + '0' );
		}

	if( owner != 0 ) {
		const char *title = ((TWindow *)owner)->getTitle(l);
		if( title != 0 ) {
			l = min( cstrlen(title), l);
			l = max( l, 0 );
//			  i = (width - l) >> 1;
			i=3;
			b.putChar( i-1, ' ' );
			b.moveBuf( i, title, cTitle, l );
			b.putChar( i+l, ' ' );
		}
	}

//	  if( (state & sfActive) != 0 ) {
		if( ( ((TWindow *)owner)->flags & wfClose ) != 0 )
			b.moveCStr( IS[GT][0], gteSBtn, 0x70 );
		if( ( ((TWindow *)owner)->flags & wfZoom ) != 0 ) {
			TPoint minSize, maxSize;
			owner->sizeLimits( minSize, maxSize );
			if( owner->size == maxSize )
				b.moveCStr( width-IS[GT][1], gteDBtn, 0x70 );
			else
				b.moveCStr( width-IS[GT][1], gteUBtn, 0x70 );
		}
		else b.moveCStr(width-1,gteLBor,cTitle&0xf0);
//	  }

	writeLine( 0, 0, size.x, 1, b );
	for( i = 1; i <=  size.y - 2; i++ )
		{
		frameLine( b, i, 3, cFrame );
		writeLine( 0, i, size.x, 1, b );
		}
	frameLine( b, size.y - 1, 6, cFrame );
	if( (state & sfActive) != 0 )
		if( ( ((TWindow *)owner)->flags & wfGrow ) != 0 )
			b.moveCStr( width-2, gteEBtn, 0x70 );
	writeLine( 0, size.y - 1, size.x, 1, b );
  }
}

TPalette& TFrame::getPalette() const
{
	static TPalette palette( cpFrame, sizeof( cpFrame )-1 );
	return palette;
}

void TFrame::dragWindow( TEvent& event, uchar mode )
{
	TRect  limits;
	TPoint min, max;

	limits = owner->owner->getExtent();
	owner->sizeLimits( min, max );
	owner->dragView( event, owner->dragMode | mode, limits, min, max );
	clearEvent( event );
}

void TFrame::handleEvent( TEvent& event )
{
	TView::handleEvent(event);
	if( event.what== evMouseDown && (state & sfActive) != 0 )
		{
		TPoint mouse = makeLocal( event.mouse.where );
		if( mouse.y == 0 )
			{
			if( ( ((TWindow *)owner)->flags & wfClose ) != 0 &&
					mouse.x >= IS[GT][0] &&
					mouse.x <= IS[GT][0]+IS[GT][2])
				{
				event.what= evCommand;
				event.message.command = cmClose;
				event.message.infoPtr = owner;
				putEvent( event );
				clearEvent( event );
				}
			else
				if( (((TWindow *)owner)->flags & wfZoom) != 0 &&
					( (mouse.x >= size.x-IS[GT][1] &&
					  mouse.x <= size.x-IS[GT][1]+IS[GT][2]) ||
					   event.mouse.doubleClick
					)
				  )
					{
					event.what= evCommand;
					event.message.command = cmZoom;
					event.message.infoPtr = owner;
					putEvent( event );
					clearEvent( event );
					}
				else
					if( ( ((TWindow *)owner)->flags & wfMove ) != 0 )
						dragWindow( event, dmDragMove );
			}
	else
		if( mouse.x >= size.x - 2 && mouse.y >= size.y - 1 )
		if( ( ((TWindow *)owner)->flags & wfGrow ) != 0 )
			dragWindow( event, dmDragGrow );
	}
}

void TFrame::setState( ushort aState, Boolean enable )
{
	TView::setState( aState, enable );
	if( (aState & (sfActive | sfDragging)) != 0 )
	drawView();
}

TStreamable *TFrame::build()
{
	return new TFrame( streamableInit );
}

TFrame::TFrame( StreamableInit ) : TView( streamableInit )
{
}


static char FrameMask[maxViewWidth];
void TFrame::frameLine( TDrawBuffer& frameBuf, short y, short n, uchar color )
{
if (!GT) {

  ushort si,ax,cx,dx,di;
  int i=1;
  TView *view;
  cx = dx = size.x;
  cx -= 2;
  FrameMask[0] = initFrame[n];
  while (cx--) FrameMask[i++] = initFrame[n+1];
  FrameMask[i] = initFrame[n+2];
  view = owner->last;
  dx--;
lab1:
  view = view->next;
  if (view == this) goto lab10;
  if (!(view->options & ofFramed)) goto lab1;
  if (!(view->state & sfVisible)) goto lab1;
  ax = y - view->origin.y;
  if ((short)(ax)<0) goto lab3;
  if (ax>view->size.y) goto lab1;
  if (ax<view->size.y) ax = 5;
	else ax = 0x0a03;
  goto lab4;
lab3:
  ax++;
  if (ax) goto lab1;
  ax = 0x0a06;
lab4:
  si = view->origin.x;
  di = si + view->size.x;
  if (si>1) goto lab5;
  si = 1;
lab5:
  if (di<dx) goto lab6;
  di = dx;
lab6:
  if (si>=di) goto lab1;
  FrameMask[si-1] |= (ax & 0x00ff);
  ax ^= (((ax & 0xff00) >> 8) & 0x00ff);
  FrameMask[di] |= (ax & 0x00ff);
  if (!(ax & 0xff00)) goto lab1;
  cx = di-si;
  while (cx--) FrameMask[si++] |= (((ax & 0xff00) >> 8) & 0x00ff);
  goto lab1;
lab10:
  dx++;
  {
	uchar * framechars = (uchar *)malloc(dx);
	for (i=0;i<dx;i++) framechars[i] = (uchar)frameChars[FrameMask[i]];
	frameBuf.moveBuf(0,framechars,color,dx);
	free(framechars);
  }
#if 0
  ax = color << 8;
  cx = dx;
  si = 0;
  i = 0;
  while (cx--)
  {
	((ushort *)(frameBuf.data))[i] = ((uchar)frameChars[FrameMask[i]]) | (ax & 0xff00);
	i++;
  }
#endif
}


else {
  ushort cx,dx;
  int i=1;
  cx = dx = size.x;
  cx -= 2;
  FrameMask[0] = GTTFrameinitFrame[n];
  while (cx--) FrameMask[i++] = GTTFrameinitFrame[n+1];
  FrameMask[i] = GTTFrameinitFrame[n+2];
  uchar * framechars = (uchar *)malloc(dx);
  for (i=0;i<dx;i++) framechars[i] = (uchar)GTTFrameframeChars[FrameMask[i]];
  frameBuf.moveBuf(0,framechars,color,dx);
  free(framechars);
}

}

