/*------------------------------------------------------------*/
/* filename -		tradiobu.cpp							  */
/*															  */
/* function(s)												  */
/*					TRadioButtons member functions			  */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*															  */
/*	  Turbo Vision -  Version 1.0							  */
/*															  */
/*															  */
/*	  Copyright (c) 1991 by Borland International			  */
/*	  All Rights Reserved.									  */
/*															  */
/*------------------------------------------------------------*/

#define Uses_TRadioButtons
#define Uses_TStreamableClass
#include <tv.h>
extern int gteGraphicText;
#define GT gteGraphicText
#include "../gte32.h"

static const char GTTRadioButton[]={EmptyCircle1,EmptyCircle2,0,DotInCircle1,DotInCircle2,0};
void TRadioButtons::draw()
{
  if (!GT)
	drawBox( button, 7 );
  else
	drawBox(GTTRadioButton,0);
}

Boolean TRadioButtons::mark( int item )
{
	return Boolean( item == value );
}

void TRadioButtons::press( int item )
{
	value = item;
}

void TRadioButtons::movedTo( int item )
{
	value = item;
}

void TRadioButtons::setData( void * rec )
{
	TCluster::setData(rec);
	sel = value;
}

TStreamable *TRadioButtons::build()
{
	return new TRadioButtons( streamableInit );
}

TRadioButtons::TRadioButtons( StreamableInit ) : TCluster( streamableInit )
{
}
