// Info Viewer V1.0 Copyright (C) 1997 Wen-Shin Wang

/* GTE/32 Copyright 1997 Wen-Shin Wang
   This converter does not check lots syntex of data files,
   make sure that there is no empty lines, only defines in chardef.h
   and icons.dat is in right format. */

#include <stdio.h>

int c1(FILE *f) {
int l=0,c,v=0,m=0x80;

	while (l<8) {
		c=fgetc(f);
		if (c==EOF) return EOF;
		if (c=='\n') return -1;
		if (c!='.') v|=m;
		l++;m>>=1;
	}
	while ((c!='\n')&&(c!=EOF)) c=fgetc(f);
	return v;
}

void main(int argc,char** argv)
{
FILE *f;
unsigned char index[256],i8x16[256][16],i8x14[256][14],i8x8[256][8],defs[256][64],buf[64];
int i,j,k,l,v,c=0;

	for (i=0;i<255;i++) defs[i][0]=0;
	strcpy(defs[255],"nouse");
	l=0;
	f=fopen("chardef.h","rt");
	while (!feof(f)) {
		i=fscanf(f,"#define %s %i\n",buf,&v);
		l++;
		if (i!=2) {
			fprintf(stderr,"an error in chardef.h at line %i\n",l);
			exit(1);
		}
		strcpy(defs[v],buf);
	}
	fclose(f);

	l=0;
	f=fopen("icons.dat","rt");
	while (!feof(f)) {
		l++;
		if (fscanf(f,"%s\n",buf)!=1) break;
		for (i=0;i<256;i++) if (strcmp(buf,defs[i])==0) break;
		if (i>=256) {
			fprintf(stderr,"unknown define at line %i\n",l);
			exit(1);
		}
		index[c]=i;
		for (k=0;k<3;k++) {
			l++;
			if (fscanf(f,"%i\n",&v)!=1) {
				fprintf(stderr,"pattern size expected at line %i\n",l);
				exit(1);
			}
			switch (v) {
				case 16:
					for (i=0;i<16;i++,l++) i8x16[c][i]=c1(f);
				break;

				case 14:
					for (i=0;i<14;i++,l++) i8x14[c][i]=c1(f);
				break;

				case 8:
					for (i=0;i<8;i++,l++) i8x8[c][i]=c1(f);
				break;

				default: {
					fprintf(stderr,"unexpected size at line %i\n",l);
					exit(1);
				}
			}
			fscanf(f,"\n");l++;
		}
		c++;
	}
	fclose(f);

	f=fopen("icons.s","wt");
	fprintf(f,".text\n.global _IconIndex\n_IconIndex:\n.byte ");
	for (i=0;i<c;i++) fprintf(f,"0x%x,",index[i]);
	fprintf(f,"0\n\n");

	l=16;
	fprintf(f,".global _Icon8x%i\n_Icon8x%i:\n",l,l);
	fprintf(f,".byte 16\n");
	for (j=0;j<c;j++) {
		fprintf(f,".byte ");
		for (i=0;i<l;i++) if (i<l-1) fprintf(f,"0x%02x,",i8x16[j][i]); else fprintf(f,"0x%02x\n",i8x16[j][i]);
	}
	fprintf(f,"\n");

	l=14;
	fprintf(f,".global _Icon8x%i\n_Icon8x%i:\n",l,l);
	fprintf(f,".byte 14\n");
	for (j=0;j<c;j++) {
		fprintf(f,".byte ");
		for (i=0;i<l;i++) if (i<l-1) fprintf(f,"0x%02x,",i8x14[j][i]); else fprintf(f,"0x%02x\n",i8x14[j][i]);
	}
	fprintf(f,"\n");

	l=8;
	fprintf(f,".global _Icon8x%i\n_Icon8x%i:\n",l,l);
	fprintf(f,".byte 8\n");
	for (j=0;j<c;j++) {
		fprintf(f,".byte ");
		for (i=0;i<l;i++) if (i<l-1) fprintf(f,"0x%02x,",i8x8[j][i]); else fprintf(f,"0x%02x\n",i8x8[j][i]);
	}
	fprintf(f,"\n");

	fclose(f);
}
