// Info Viewer V1.0 Copyright (C) 1997 Wen-Shin Wang

#if !defined(_TINFO_H_)
#define _TINFO_H_

#include "gadgets.h"
#include "inf.h"

class TInfoViewer:public TApplication
{
public:
	TInfoViewer(int argc,char* argv[]);
	~TInfoViewer();
	static TStatusLine *initStatusLine( TRect r );
	static TMenuBar *initMenuBar( TRect r );
	virtual void handleEvent( TEvent& event);
	virtual void idle();
	virtual TPalette& getPalette() const;

private:
	TClockView *clock;
	THeapView *heap;
	void About();
};

class TIVInfWindow : public TInfWindow {
public:
  TIVInfWindow(TInfFile *, char *, char *match = NULL);
  ~TIVInfWindow();
};

const cmAbout		= 0x401,
	  cmAsciiChart	= 0x402;

#define cpTInfoViewerColor\
	"\x71"\
	"\x70\x78\x74\x20\x28\x24"\
	"\x17\x1F\x1A\x31\x31\x1E\x71\x00"\
	"\x37\x3F\x3A\x13\x13\x3E\x21\x00"\
	"\x07\x0F\x0F\x07\x0F\x07\x70\x00"\
	"\x70\x7F\x7A\x13\x13\x70\x70\x7F\x7E\x20\x2B\x2F\x78\x2E\x70\x30"\
	"\x3F\x3E\x1F\x2F\x1A\x20\x72\x31\x31\x30\x2F\x3E\x31\x13\x1F\x00"\
	"\x1E\x71\x17\x1F\x1E\x1F\x1B\x1D\x1D\x1D\x1D\x1B\x1A\x40"\
	"\x3E\x23\x1E\x1E\x1E\x1E\x1E\x1E\x1E\x1E\x1E\x1E\x1E\x1E"\
	"\x70\x7F\x1E\x1E\x1E\x1E\x1E\x1E\x1E\x1E\x1E\x1E\x1E\x1E"\
	"\x37\x3F\x3A\x13\x13\x30\x3E\x1E\x4E\x2E"\
	"\x07\x0F\x07\x70\x70\x07\x0F\x70\x0F\x70"\
	"\x07\x0F\x07\x70\x70\x07\x0F\x70\x0F\x70"

#endif
