// Info Viewer V1.0 Copyright (C) 1997 Wen-Shin Wang

#if !defined( __GADGETS_H )
#define __GADGETS_H

#define Uses_TEvent
#define Uses_TRect
#define Uses_TView
#include <tv.h>

//-------------------------

class THeapView : public TView
{
public:
	THeapView(const TRect & r) : TView(r), p_mem(0), v_mem(0) {};
	void update();
	virtual void draw();
private:
	unsigned long p_mem,v_mem;
};

void get_mem_info(unsigned long &,unsigned long &);

//-------------------------

class TClockView : public TView
{

public:

	TClockView( TRect& r );
	virtual void draw();
	virtual void update();

private:

	char lastTime[9];
	char curTime[9];

};

#endif		// __GADGETS_H
